/*
 * upLoad.java
 * June 1998, Jean-Marc Koller
 */

package KheperaTerminal;

import java.io.BufferedInputStream;
import java.io.OutputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.FileNotFoundException;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;
import java.awt.Dimension;
import java.awt.Toolkit;

public class upLoad extends Thread implements ActionListener, WindowListener
{
  JFrame frame;
  JPanel panel;
  JProgressBar pbar;
  boolean abort;
  BufferedInputStream bfin = null;
  OutputStream serialOutput;

  public void actionPerformed (ActionEvent e)
  {
    abort = true;
  }

  public void windowClosed (WindowEvent e)
  {
  }
  public void windowDeiconified (WindowEvent e)
  {
  }
  public void windowIconified (WindowEvent e)
  {
  }
  public void windowActivated (WindowEvent e)
  {
  }
  public void windowDeactivated (WindowEvent e)
  {
  }
  public void windowOpened (WindowEvent e)
  {
  }
  public void windowClosing (WindowEvent e)
  {
    abort = true;
  }

  static final int BufSize = 64;
  public upLoad (String filename, OutputStream _serialOutput) throws IOException
  {
    abort = false;
    serialOutput = _serialOutput;
    try
    {
      bfin = new BufferedInputStream (new FileInputStream (filename));
    }
    catch (FileNotFoundException fnfe)
    {
    }
    if (bfin == null || bfin.available () == 0)
      {
	System.out.println ("upLoad(\"" + filename + "\") : empty file!");
	return;
      }
    String restartCommand = "restart\n";
    serialOutput.write (restartCommand.getBytes ());
    try
    {
      sleep (800);
    }
    catch (InterruptedException ie)
    {
    }
    String sloaderCommand = "run sloader\n\r";
    serialOutput.write (sloaderCommand.getBytes ());

    frame = new JFrame ("Uploading");
    panel = new JPanel ();
    pbar = new JProgressBar ();
    pbar.setMinimum (0);
    pbar.setMaximum (bfin.available ());
    pbar.setValue (0);
    pbar.getAccessibleContext ().setAccessibleName ("Khepera S-Load progress");
    panel.add (pbar);
    JButton but = new JButton ("Stop");
    but.addActionListener (this);
    panel.add (but);
    frame.getContentPane ().add ("Center", panel);
    frame.addWindowListener (this);
    frame.pack ();
    Dimension screenSize = Toolkit.getDefaultToolkit ().getScreenSize ();
    Dimension frameSize = frame.getSize ();
    frame.setLocation (screenSize.width / 2 - frameSize.width / 2, screenSize.height / 2 - frameSize.height / 2);
    frame.show ();
    start ();
  }

  public void run ()
  {
    int c = 0;
      byte[] buffer = new byte[BufSize];
      try
    {
      while (bfin.available () > 0 && !abort)
	{
	  int l = bfin.read (buffer, 0, BufSize);
	    serialOutput.write (buffer, 0, l);
	    c += l;
	    pbar.setValue (c++);
	}
      bfin.close ();
    }
    catch (IOException ioe)
    {
    }
    frame.getContentPane ().removeAll ();
    frame.dispose ();
  }
};
