/*
   ; K-TEAM Make Utility
   ; ===================
   ;
   ;------------------------------------------------------------------------
   ; Author:    Olivier Carmona  07/99
   ;
   ; Project:   KHEPERA
   ; Goal:              Source file of the K-TEAMMake Utility
   ;
   ;
   ;------------------------------------------------------------------------
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * An application that displays a JButton and several JRadioButtons.
 * The JRadioButtons determine the look and feel used by the application.
 */
public class Make extends JPanel implements ActionListener {
    static JFrame frame;
    JTextField sourceField;
    JTextField sourceDirField;
    JTextField goalField;
    JButton make;

    public Make() {
	// Create the buttons.

        add(new JLabel("Please enter the following information:"));
        sourceDirField = new JTextField();
        sourceDirField.setText("");
        sourceDirField.setMinimumSize(new Dimension(50, 25));
        sourceDirField.setEditable(true);
        sourceDirField.getAccessibleContext().setAccessibleName("Source Directory");
        add(sourceDirField);


        sourceField = new JTextField();
        sourceField.setText("");
        sourceField.setMinimumSize(new Dimension(50, 25));
        sourceField.setEditable(true);
        sourceField.getAccessibleContext().setAccessibleName("Source file list separated by white space");
        add(sourceField);

        goalField = new JTextField();
        goalField.setText("");
        goalField.setMinimumSize(new Dimension(50, 25));
        goalField.setEditable(true);
        goalField.getAccessibleContext().setAccessibleName("Source File List Separated by white space");

	make = new JButton("Make");
        add(goalField, "Center");
	add(make);
    }


    public void actionPerformed(ActionEvent e) 
    {
     if(e.getSource() == make) 
      {
       
      }	    
    }	    

    public void updateState() {
    }

    public static void main(String s[]) {
	Make panel = new Make();
	
	frame = new JFrame("KheperaMake");
	frame.addWindowListener(new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {System.exit(0);}
	});
	frame.getContentPane().add("Center", panel);
	frame.pack();
	frame.setVisible(true);
	
	panel.updateState();
    }
}
