/*
 * Analyzer.java
 * June 1998, Jean-Marc Koller
 */

package KheperaTerminal;

import java.awt.Component;
import javax.swing.JPanel;
import java.io.FileOutputStream;
import java.io.IOException;

public interface Analyzer
{
	public void setTime( int mintime, int maxtime );
	public int addData( int timestamp, byte[] buffer, int offset );
	public int exportData( FileOutputStream fo, byte[] buffer, int offset ) throws IOException;
	public int DataSize();
	public Component getComponent();
	public void addComponent( JPanel panel );
	public String getName();
	public void incSize();
	public void setZoomTime( int factor );
	public void setZoomValue( int factor );
};
