/*
 * ButtonInstrument.java
 * June 1998, Jean-Marc Koller
 */

package KheperaTerminal;

import javax.swing.JPanel;
import javax.swing.JButton;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.awt.Component;
import java.io.FileOutputStream;
import java.io.IOException;

public class ButtonInstrument implements Instrument, ActionListener
{
  JButton button;
  int handler;
  String tname;

  public void actionPerformed (ActionEvent e)
  {
    byte buffer[] = new byte[6];
      buffer[0] = (byte)'@';
      buffer[1] = (byte)'I';
      buffer[2] = (byte)'b';
      buffer[3] = (byte) handler;
      buffer[4] = (byte)0;
      buffer[5] = (byte)'K';
      /* terminal.sendData( buffer ); */
  }

  public ButtonInstrument (JPanel panel, String pname, int nbparams, byte[]params, int curHandler)
  {
    tname = pname;
    handler = curHandler;
    button = new JButton (tname);
    button.addActionListener (this);
    panel.add (button);
  }

  public void update (byte[]data, int offset)
  {
  }

  public void performUpdateObject ()
  {
  }

  public int DataSize ()
  {
    return 0;
  }

  public Analyzer createAnalyzer ()
  {
    return new ButtonInstrument.analyzer ();
  }

  protected class analyzer extends Component implements Analyzer
  {
    int nb = 0;

      analyzer ()
    {
    }

    public void setTime (int mintime, int maxtime)
    {
    }

    public int addData (int timestamp, byte[]buffer, int offset)
    {
      return 0;
    }

    public int exportData (FileOutputStream fo, byte[]buffer, int offset) throws IOException
    {
      if (buffer != null)
	fo.write ('1');
      return 1;
    }

    public int DataSize ()
    {
      return 0;
    }

    public Component getComponent ()
    {
      return this;
    }

    public void incSize ()
    {
      nb++;
    }

    public String getName ()
    {
      return "Button " + tname;
    }

    public void addComponent (JPanel panel)
    {
      panel.add (this);
    }

    public void setZoomTime (int factor)
    {
    }

    public void setZoomValue (int factor)
    {
    }

  };

};
